// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE. 
// 
// Copyright 2002 Gottfried Rudorfer.  All Rights Reserved. 
// 
//  MODULE:   ReadParse.h
// 
//  PURPOSE:  Implements logo for program.
// 
//  COMMENTS: 
// 
//  AUTHOR: Gottfried Rudorfer
//			http://godefroy.sdf-eu.org/notes_mail/
// 
//====================================================================================

//******************************************************************************
// ReadParse.h
// Copyright 1999 by Gottfried Rudorfer
//
// E-Mail: Gottfried.Rudorfer@ai.wu-wien.ac.at
//
// All rights reserved.
//******************************************************************************

// Documentation: ***************************************************************
// VARIABLES:
// in .... map of key/value pairs
//******************************************************************************



#include <iostream>
#include <fstream>
#include <string>
#include <map>
#include <new.h>

using namespace std;

extern "C"
{
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
}

// characters that we accept (according to CERT)
const char _ok_chars[] = "abcdefghijklmnopqrstuvwxyz\
ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_-+.@%=&";

typedef map<string,string> StringStringMap;

int CgiNoSpace(size_t);

class ReadParse 
{
public:
  ReadParse();
  ~ReadParse();
  void PrintHeader();
  string EvalString(const string);
  string EvalFile(const string);
  void Mygetenv(char*);
  StringStringMap in;
  int strnicmp(const char *s1, const char *s2, const int count);
  int HexToChar(char *strptr, char &thechar);
private:
  void Parse();
  char *_html_string;
  int _has_parsed;
  string Line(const string& text, const string::size_type pos);
  char *_env_string;
  char *CertFix(char*); 
};

